package com.perforce.hws.testing;

import org.testng.annotations.AfterSuite;
import org.testng.annotations.BeforeSuite;

import com.perforce.hws.automation.BasicMainlineEnvironmentSetup;

import java.io.IOException;

/**
 * Use this to launch our basic setup, which simulates a typical on-premise
 * server.
 */
public class BasicMainlineEnvironmentTestSetup implements SuiteCleanupHelpers {

    BasicMainlineEnvironmentSetup setup = null;

    @BeforeSuite(dependsOnGroups = "log4j")
    public void runBasicEnvironmentSetup() {
        try {

            if (setup == null) {
                setup = new BasicMainlineEnvironmentSetup();
            }
            setup.run();
            ServerProvider.setProvider(setup);
            ClientProvider.setConfig(setup.config());
        } catch (Exception e) {
            e.printStackTrace();
            System.err.println("Configuration failure, HALTING");
            setup = null;
        }
    }

    @AfterSuite
    public void cleanupEnvironment() {
        try {
            cleanUp(setup.coverageOutputPath(), "BasicMainlineTest.exec");
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
