package com.perforce.hws.testing;

import org.testng.annotations.Factory;

import com.perforce.hws.automation.ProjectLocations;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.List;

public class JavascriptTestFactory implements ProjectLocations {

    /**
     * Loads up all javascript tests and generates an ExecJavascripTest instance for each of them.
     * @return
     */
    @Factory
    public Object[] createJavascriptTests() {
        List<ExecJavascriptTest> tests = new ArrayList<>();

        try {
            Path clientPath = Paths.get(projectRoot(), "client-javascript");
            Path testDir = Paths.get(clientPath.toString(), "test");

            Files.list(testDir).forEach(p -> {
                if (Files.isRegularFile(p)) {
                    tests.add(new ExecJavascriptTest(clientPath.toAbsolutePath().toString(),
                            Paths.get("test", p.getFileName().toString()).toString()));
                }
            });
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }

        return tests.toArray();
    }

}
