package com.perforce.hws.testing;

import org.testng.annotations.Factory;

import com.perforce.hws.automation.ProjectLocations;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by tristan on 5/2/16.
 */
public class PhpTestFactory implements ProjectLocations {

    @Factory
    public Object[] createPhpTests() {
        List<ExecPhpTest> tests = new ArrayList<>();

        try {
            Path projectDir = Paths.get(projectRootOrFail(), "client-php");
            Path testDir = Paths.get(projectDir.toAbsolutePath().toString(), "tests");

            Files.list(testDir).forEach(p -> {
               if (Files.isRegularFile(p)) {
                   tests.add(new ExecPhpTest(projectDir.toAbsolutePath().toString(),
                           Paths.get("tests", p.getFileName().toString()).toString()));
               }
            });
        } catch (IOException e) {
            e.printStackTrace();
            return null;
        }

        return tests.toArray();
    }
}
