package com.perforce.hws.testing;

import org.testng.annotations.Factory;

import com.perforce.hws.automation.ProjectLocations;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by tristan on 5/5/16.
 */
public class PythonTestFactory implements ProjectLocations {

    @Factory
    public Object[] createPythonTests() {
        List<ExecPythonTest> tests = new ArrayList<>();

        try {
            Path clientPath = Paths.get(projectRoot(), "client-python");
            Path testDir = Paths.get(clientPath.toString(), "tests");

            Files.list(testDir).forEach(p -> {
                if (Files.isRegularFile(p)) {
                    tests.add(new ExecPythonTest(clientPath.toAbsolutePath().toString(),
                            Paths.get("tests", p.getFileName().toString()).toString()));
                }
            });
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }

        return tests.toArray();
    }
}
