package com.perforce.hws.testing;

import java.nio.file.Path;
import java.nio.file.Paths;

import com.perforce.hws.automation.Cleanup;
import com.perforce.hws.automation.CopyCoverage;

/**
 * Created by tristan on 4/25/16.
 */
public interface SuiteCleanupHelpers {

    default void cleanUp(String coverageOutputPath, String coverageName) {
        if (System.getenv("DISABLE_CLEANUP") != null) {
            System.err.println("DISABLE_CLEANUP is set, so not cleaning up");
            return;
        }
        try {
            Cleanup cleanup = new Cleanup();

            cleanup.stopHWS();

            Path coveragePath = Paths.get(coverageOutputPath, coverageName);
            CopyCoverage copyCoverage = new CopyCoverage(coveragePath.toAbsolutePath().toString());
            copyCoverage.run();

            cleanup.run();

        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
