package com.perforce.hws.testing.proxy;

import com.perforce.hws.automation.Basic16_1EnvironmentSetup;
import com.perforce.hws.testing.ExampleProxy;
import com.perforce.hws.testing.SuiteCleanupHelpers;
import com.perforce.hws.testing.Uses16_1Environment;
import org.testng.annotations.AfterSuite;
import org.testng.annotations.BeforeSuite;

/**
 * A variation that launches our basic environment, and, a proxy server to just
 * talk to it to see if we can mount HWS under a different context path.
 */
public class ProxyEnvironmentTestSetup implements SuiteCleanupHelpers, Uses16_1Environment {

    Basic16_1EnvironmentSetup environmentSetup = null;

    ExampleProxy exampleProxy = null;


    @BeforeSuite(dependsOnGroups = "log4j")
    public void setupEnvironment() {
        environmentSetup = setup16_1Environment();

        if (environmentSetup == null) {
            return;
        }

        try {
            exampleProxy = new ExampleProxy();
            exampleProxy.start();
        } catch (Exception e) {
            e.printStackTrace();
            exampleProxy = null;
        }
    }

    @AfterSuite
    public void cleanupEnvironment() {
        try {
            cleanUp(environmentSetup.coverageOutputPath(), "ProxyEnvironmentTest.exec");
            if (exampleProxy != null) {
                exampleProxy.stop();
            }
        } catch (Exception e) {
            e.printStackTrace();
            environmentSetup = null;
        }
    }
}
