package com.perforce.hws.testing.reporting;

/**
 * Created by tristan on 5/10/16.
 */
public class MethodResult {

    public enum ResultType {
        PASSED,
        FAILED,
        SKIPPED
    }

    private String name;
    private String className;
    private ResultType resultType;
    private String log;
    private String suite;

    public MethodResult() {
    }

    public String getLog() {
        return log;
    }

    public void setLog(String log) {
        this.log = log;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public ResultType getResultType() {
        return resultType;
    }

    public void setResultType(ResultType resultType) {
        this.resultType = resultType;
    }

    public String getClassName() {
        return className;
    }

    public void setClassName(String className) {
        this.className = className;
    }

    public String getSuite() {
        return suite;
    }

    public void setSuite(String suite) {
        this.suite = suite;
    }

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (o == null || getClass() != o.getClass()) return false;

        MethodResult that = (MethodResult) o;

        if (name != null ? !name.equals(that.name) : that.name != null) return false;
        if (className != null ? !className.equals(that.className) : that.className != null)
            return false;
        if (resultType != that.resultType) return false;
        if (log != null ? !log.equals(that.log) : that.log != null) return false;
        return suite != null ? suite.equals(that.suite) : that.suite == null;

    }

    @Override
    public int hashCode() {
        int result = name != null ? name.hashCode() : 0;
        result = 31 * result + (className != null ? className.hashCode() : 0);
        result = 31 * result + (resultType != null ? resultType.hashCode() : 0);
        result = 31 * result + (log != null ? log.hashCode() : 0);
        result = 31 * result + (suite != null ? suite.hashCode() : 0);
        return result;
    }

    @Override
    public String toString() {
        return "MethodResult{" +
                "name='" + name + '\'' +
                ", resultType=" + resultType +
                ", suite='" + suite + '\'' +
                ", className='" + className + '\'' +
                '}';
    }
}
