package com.perforce.hws.testing.server;

import com.perforce.hws.testing.ClientProvider;
import com.perforce.hws.util.StringUtils;
import com.perforce.hwsclient.DefaultApi;
import com.perforce.hwsclient.models.Location;

import org.testng.annotations.Test;

import java.io.IOException;
import java.util.List;

import static org.testng.Assert.*;

public class PerforceListingTests implements StringUtils {

    @Test(dataProvider = "ProjectClientAsJDoe",
            dataProviderClass = ClientProvider.class)
    public void canListDepots(DefaultApi api) throws IOException {
        List<Location> results =
                api.getPaths("localhost", null);
        assertFalse(results.isEmpty());
        assertTrue(results.stream().anyMatch(m -> m.getDepot() != null && "my_project".equals(m.getDepot().getDepot())));
    }

    @Test(dataProvider = "ProjectClientAsJDoe",
            dataProviderClass = ClientProvider.class)
    public void canListDir(DefaultApi api) throws IOException {
        List<Location> results =
                api.getPaths("localhost", "//my_project/main");
        assertFalse(results.isEmpty());
        assertTrue(results.stream().anyMatch(m -> m.getDir() != null && "//my_project/main/Experimental".equals(m.getDir().getDir())));
        assertTrue(results.stream().anyMatch(m -> m.getFile() != null && "//my_project/main/README".equals(m.getFile().getDepotFile())));
    }

    @Test(dataProvider = "ProjectClientAsJDoe",
            dataProviderClass = ClientProvider.class)
    public void canListFile(DefaultApi api) throws IOException {
        List<Location> results =
                api.getPaths("localhost", "//my_project/main/README");
        assertFalse(results.isEmpty());
        assertNotNull(results.get(0).getFstat());
        assertNotNull(results.get(0).getContent());
    }
}