package com.perforce.hws.testing.server;

import com.perforce.hws.testing.ClientProvider;
import com.perforce.hwsclient.DefaultApi;
import com.perforce.hwsclient.models.Protections;

import org.testng.annotations.Test;

import java.io.IOException;

import static org.testng.Assert.assertTrue;

/**
 * Tests underneath the /p4/:api/protections routes.
 */
public class PerforceProtectionsTests {

    @Test(dataProvider = "ProjectClientAsSuper",
            dataProviderClass = ClientProvider.class)
    public void canFetchAndUpdate(DefaultApi api) throws IOException {
        Protections protections =
                api.getProtections("localhost");

        assertTrue(protections.getProtections().size() >= 2);

        protections.getProtections().add("super user jdoe * //...");

        api.updateProtections("localhost", protections);

        Protections updated =
                api.getProtections("localhost");

        assertTrue(updated.getProtections().contains("super user jdoe * //..."));
    }
}
