package com.perforce.hws.testing.servlet;

import com.perforce.hws.automation.Basic16_1EnvironmentSetup;
import com.perforce.hws.testing.ServletContainer;
import com.perforce.hws.testing.SuiteCleanupHelpers;
import com.perforce.hws.testing.Uses16_1Environment;
import org.testng.annotations.AfterSuite;
import org.testng.annotations.BeforeSuite;

/**
 * A variation that spins up a basic servlet host that puts our server on a
 * new context path.
 */
public class ServletEnvironmentTestSetup implements SuiteCleanupHelpers, Uses16_1Environment {

    Basic16_1EnvironmentSetup environmentSetup = null;

    ServletContainer servletContainer = null;

    @BeforeSuite(dependsOnGroups = "log4j")
    public void setupEnvironment() {
        environmentSetup = setup16_1Environment();

        if (environmentSetup == null) {
            return;
        }

        try {
            System.setProperty("PREFIX", "/webservices");
            System.setProperty("P4DCONFIGDIR", "./servlet/config/p4ds");
            System.setProperty("HWS_AUTH_P4D", "localhost");
            System.setProperty("JWT_SIGNING_KEY",
                    "MheXr1H5GGLvLpLDbQ4pofTAHN6ISUG7wBNRA89926ar9rZYfB5bnqPzi90E/Vef7m43img9Z6pydO/2W5b3kw==");
            servletContainer = new ServletContainer();
            servletContainer.start();
        } catch (Exception e) {
            e.printStackTrace();
            servletContainer = null;
        }
    }

    @AfterSuite
    public void cleanupEnvironment() {
        try {
            cleanUp(environmentSetup.coverageOutputPath(), "ProxyEnvironmentTest.exec");
            if (servletContainer != null) {
                servletContainer.stop();
            }
        } catch (Exception e) {
            e.printStackTrace();
            environmentSetup = null;
        }
    }
}
